''***************************************************
''*   Program to test  SD Data Logger Object v1.0   *
''*     (C) 2006 Hitt Consulting                    *
''*     terry@hittconsulting.com                    *
''***************************************************


CON
  _clkmode = xtal1 + pll8x  ' Overlay object REQUIRES 40MHz
  _xinfreq = 5_000_000

  SD_PIN = 3  ' SD Data Logger connected to pin P3

  CR = 13
  LF = 10 ' Default string terminator for the SD Data Logger

  SD_ERROR_OKAY = 0
  SD_ERROR_EOF  = 7


VAR
  BYTE tempStr[256]  ' Holds a string 
  BYTE error         ' Data Logger error code
  LONG Screen        ' Holds address of screen bitmap


OBJ
  debug: "HITT_Video_Overlay_012"
  sd:    "HITT_SD_Logger_010"


PUB TestSDDataLogger
  Screen:=debug.Init

  sd.Init(SD_PIN)
  sd.Pacing(0)
  sd.WakeUp    ' Get out of sleep mode
  sd.CloseFile ' In case a file has been left open

  ' Open file "PROP.TXT" and append 24 strings to it
  error:=sd.OpenFile(STRING("PROP.TXT"))
  REPEAT 24
    IF error == SD_ERROR_OKAY
      error:=sd.AppendStr(STRING("THIS IS A TEST...ONLY A TEST...", LF))
    ELSE
      debug.PutStr(STRING("Error creating file...", CR))  
  sd.CloseFile
  
 ' Open file "PROP.TXT" and display all the strings in it
  error:=sd.OpenFile(STRING("PROP.TXT"))
  IF error == SD_ERROR_OKAY
    REPEAT UNTIL error <> 0
      error:=sd.ReadStr(@tempStr) ' *** NOTICE "@"
      IF error == SD_ERROR_OKAY OR error == SD_ERROR_EOF
        debug.PutStr(@tempStr)    ' *** NOTICE "@"
        debug.PutStr(STRING(CR))
  ELSE
    debug.PutStr(STRING("Error opening file...", CR))    
  sd.CloseFile

  ' Save the screen bitmap to the Data Logger SRAM address 0
  sd.WriteMemory(0, Screen, 6144)

  debug.Cls(0)

  ' Load the screen bitmap from from the Data Logger SRAM address 0
  sd.ReadMemory(0, Screen, 6144)

  ' Save the screen bitmap to file "SCREEN.DAT"  
  error:=sd.OpenFile(STRING("SCREEN.DAT"))
  IF error == SD_ERROR_OKAY
    sd.AppendBlock(Screen, 6144)
  sd.CloseFile

  debug.Cls(0)

  ' Load the screen bitmap from file "SCREEN.DAT"
  error:=sd.OpenFile(STRING("SCREEN.DAT"))
  IF error == SD_ERROR_OKAY
    sd.ReadBlock(Screen, 6144)
  sd.CloseFile

